Index: plugins/blowupConfig/lib/class.blowup.config.php
===================================================================
--- plugins/blowupConfig/lib/class.blowup.config.php	(revision 696)
+++ plugins/blowupConfig/lib/class.blowup.config.php	(revision 270)
@@ -22,5 +22,5 @@
 			'ss5' => 'Impact, Charcoal, sans-serif'
 		),
-
+		
 		'serif' => array(
 			's1' => 'Times, "Times New Roman", serif',
@@ -28,5 +28,5 @@
 			's3' => 'Baskerville, "Palatino Linotype", serif'
 		),
-
+		
 		'monospace' => array(
 			'm1' => '"Andale Mono", "Courier New", monospace',
@@ -34,8 +34,8 @@
 		)
 	);
-
+	
 	protected static $fonts_combo = array();
 	protected static $fonts_list = array();
-
+	
 	public static $top_images = array(
 		'default' => 'Default',
@@ -53,7 +53,7 @@
 		'roadrunner-1' => 'Road Runner 1',
 		'roadrunner-2' => 'Road Runner 2',
-		'typo' => 'Typo'
+		'typo' => 'Typo',
 	);
-
+	
 	public static function fontsList()
 	{
@@ -70,8 +70,8 @@
 			}
 		}
-
+		
 		return self::$fonts_combo;
 	}
-
+	
 	public static function fontDef($c)
 	{
@@ -85,8 +85,8 @@
 			}
 		}
-
+		
 		return isset(self::$fonts_list[$c]) ? self::$fonts_list[$c] : null;
 	}
-
+	
 	public static function adjustFontSize($s)
 	{
@@ -97,8 +97,8 @@
 			return $m[1].$m[2];
 		}
-
+		
 		return null;
 	}
-
+	
 	public static function adjustPosition($p)
 	{
@@ -106,10 +106,10 @@
 			return null;
 		}
-
+		
 		$p = explode(':',$p);
-
+		
 		return $p[0].(count($p) == 1 ? ':0' : ':'.$p[1]);
 	}
-
+	
 	public static function adjustColor($c)
 	{
@@ -117,28 +117,22 @@
 			return '';
 		}
-
+		
 		$c = strtoupper($c);
-
+		
 		if (preg_match('/^[A-F0-9]{3,6}$/',$c)) {
 			$c = '#'.$c;
 		}
-
+		
 		if (preg_match('/^#[A-F0-9]{6}$/',$c)) {
 			return $c;
 		}
-
+		
 		if (preg_match('/^#[A-F0-9]{3,}$/',$c)) {
 			return '#'.substr($c,1,1).substr($c,1,1).substr($c,2,1).substr($c,2,1).substr($c,3,1).substr($c,3,1);
 		}
-
+		
 		return '';
 	}
-
-	public static function cleanCSS($css)
-	{
-		// TODO ?
-		return $css;
-	}
-
+	
 	public static function imagesPath()
 	{
@@ -146,5 +140,5 @@
 		return path::real($core->blog->public_path).'/blowup-images';
 	}
-
+	
 	public static function imagesURL()
 	{
@@ -152,12 +146,12 @@
 		return $core->blog->settings->system->public_url.'/blowup-images';
 	}
-
+	
 	public static function canWriteImages($create=false)
 	{
 		global $core;
-
+		
 		$public = path::real($core->blog->public_path);
 		$imgs = self::imagesPath();
-
+		
 		if (!function_exists('imagecreatetruecolor') || !function_exists('imagepng') || !function_exists('imagecreatefrompng')) {
 			$core->error->add(__('At least one of the following functions is not available: '.
@@ -165,10 +159,10 @@
 			return false;
 		}
-
+		
 		if (!is_dir($public)) {
 			$core->error->add(__('The \'public\' directory does not exist.'));
 			return false;
 		}
-
+		
 		if (!is_dir($imgs)) {
 			if (!is_writable($public)) {
@@ -181,13 +175,13 @@
 			return true;
 		}
-
+		
 		if (!is_writable($imgs)) {
 			$core->error->add(sprintf(__('The \'%s\' directory cannot be modified.'),'public/blowup-images'));
 			return false;
 		}
-
+		
 		return true;
 	}
-
+	
 	public static function uploadImage($f)
 	{
@@ -195,26 +189,26 @@
 			throw new Exception(__('Unable to create images.'));
 		}
-
+		
 		$name = $f['name'];
 		$type = files::getMimeType($name);
-
+		
 		if ($type != 'image/jpeg' && $type != 'image/png') {
 			throw new Exception(__('Invalid file type.'));
 		}
-
+		
 		$dest = self::imagesPath().'/uploaded'.($type == 'image/png' ? '.png' : '.jpg');
-
+		
 		if (@move_uploaded_file($f['tmp_name'],$dest) === false) {
 			throw new Exception(__('An error occurred while writing the file.'));
 		}
-
+		
 		$s = getimagesize($dest);
 		if ($s[0] != 800) {
 			throw new Exception(__('Uploaded image is not 800 pixels wide.'));
 		}
-
+		
 		return $dest;
 	}
-
+	
 	public static function createImages(&$config,$uploaded)
 	{
@@ -225,7 +219,7 @@
 		$comment_color_my = $config['post_commentmy_bg_c'];
 		$top_image = $config['top_image'];
-
+		
 		$config['top_height'] = null;
-
+		
 		if ($top_image != 'custom' && !isset(self::$top_images[$top_image])) {
 			$top_image = 'default';
@@ -234,9 +228,9 @@
 			$uploaded = null;
 		}
-
+		
 		if (!self::canWriteImages(true)) {
 			throw new Exception(__('Unable to create images.'));
 		}
-
+		
 		$body_fill = array(
 			'light' => dirname(__FILE__).'/../alpha-img/gradient-l.png',
@@ -244,7 +238,7 @@
 			'dark' => dirname(__FILE__).'/../alpha-img/gradient-d.png'
 		);
-
+		
 		$body_g = isset($body_fill[$gradient]) ? $body_fill[$gradient] : false;
-
+		
 		if ($top_image == 'custom' && $uploaded) {
 			$page_t = $uploaded;
@@ -252,5 +246,5 @@
 			$page_t = dirname(__FILE__).'/../alpha-img/page-t/'.$top_image.'.png';
 		}
-
+		
 		$body_bg = dirname(__FILE__).'/../alpha-img/body-bg.png';
 		$page_t_mask = dirname(__FILE__).'/../alpha-img/page-t/image-mask.png';
@@ -260,5 +254,5 @@
 		$default_bg = '#e0e0e0';
 		$default_prelude = '#ededed';
-
+		
 		self::dropImage(basename($body_bg));
 		self::dropImage('page-t.png');
@@ -266,9 +260,9 @@
 		self::dropImage(basename($comment_t));
 		self::dropImage(basename($comment_b));
-
+		
 		$body_color = self::adjustColor($body_color);
 		$prelude_color = self::adjustColor($prelude_color);
 		$comment_color = self::adjustColor($comment_color);
-
+		
 		if ($top_image || $body_color || $gradient != 'light' || $prelude_color || $uploaded)
 		{
@@ -277,10 +271,10 @@
 			}
 			$body_color = sscanf($body_color,'#%2X%2X%2X');
-
+			
 			# Create body gradient with color
 			$d_body_bg = imagecreatetruecolor(50,180);
 			$fill = imagecolorallocate($d_body_bg,$body_color[0],$body_color[1],$body_color[2]);
 			imagefill($d_body_bg,0,0,$fill);
-
+			
 			# User choosed a gradient
 			if ($body_g) {
@@ -290,18 +284,18 @@
 				imagedestroy($s_body_bg);
 			}
-
+			
 			if (!$prelude_color) {
 				$prelude_color = $default_prelude;
 			}
 			$prelude_color = sscanf($prelude_color,'#%2X%2X%2X');
-
+			
 			$s_prelude = imagecreatetruecolor(50,30);
 			$fill = imagecolorallocate($s_prelude,$prelude_color[0],$prelude_color[1],$prelude_color[2]);
 			imagefill($s_prelude,0,0,$fill);
 			imagecopy($d_body_bg,$s_prelude,0,0,0,0,50,30);
-
+			
 			imagepng($d_body_bg,self::imagesPath().'/'.basename($body_bg));
 		}
-
+		
 		if ($top_image || $body_color || $gradient != 'light')
 		{
@@ -310,7 +304,7 @@
 			$size = $size[1];
 			$type = files::getMimeType($page_t);
-
+			
 			$d_page_t = imagecreatetruecolor(800,$size);
-
+			
 			if ($type == 'image/png') {
 				$s_page_t = @imagecreatefrompng($page_t);
@@ -318,12 +312,12 @@
 				$s_page_t = @imagecreatefromjpeg($page_t);
 			}
-
+			
 			if (!$s_page_t) {
 				throw new exception(__('Unable to open image.'));
 			}
-
+			
 			$fill = imagecolorallocate($d_page_t,$body_color[0],$body_color[1],$body_color[2]);
 			imagefill($d_page_t,0,0,$fill);
-
+			
 			if ($type == 'image/png')
 			{
@@ -337,15 +331,15 @@
 				# JPEG, we add image and a frame with rounded corners
 				imagecopy($d_page_t,$s_page_t,0,0,0,0,800,$size);
-
+				
 				imagecopy($d_page_t,$d_body_bg,0,0,0,50,8,4);
 				imagecopy($d_page_t,$d_body_bg,0,4,0,54,4,4);
 				imagecopy($d_page_t,$d_body_bg,792,0,0,50,8,4);
 				imagecopy($d_page_t,$d_body_bg,796,4,0,54,4,4);
-
+				
 				$mask = imagecreatefrompng($page_t_mask);
 				imagealphablending($mask,true);
 				imagecopy($d_page_t,$mask,0,0,0,0,800,11);
 				imagedestroy($mask);
-
+				
 				$fill = imagecolorallocate($d_page_t,255,255,255);
 				imagefilledrectangle($d_page_t,0,11,3,$size-1,$fill);
@@ -353,28 +347,28 @@
 				imagefilledrectangle($d_page_t,0,$size-9,799,$size-1,$fill);
 			}
-
+			
 			$config['top_height'] = ($size).'px';
-
+			
 			imagepng($d_page_t,self::imagesPath().'/page-t.png');
-
+			
 			imagedestroy($d_body_bg);
 			imagedestroy($d_page_t);
 			imagedestroy($s_page_t);
-
+			
 			# Create bottom image with color
 			$d_page_b = imagecreatetruecolor(800,8);
 			$fill = imagecolorallocate($d_page_b,$body_color[0],$body_color[1],$body_color[2]);
 			imagefill($d_page_b,0,0,$fill);
-
+			
 			$s_page_b = imagecreatefrompng($page_b);
 			imagealphablending($s_page_b,true);
 			imagecopy($d_page_b,$s_page_b,0,0,0,0,800,160);
-
+			
 			imagepng($d_page_b,self::imagesPath().'/'.basename($page_b));
-
+			
 			imagedestroy($d_page_b);
 			imagedestroy($s_page_b);
 		}
-
+		
 		if ($comment_color) {
 			self::commentImages($comment_color,$comment_t,$comment_b,basename($comment_t),basename($comment_b));
@@ -384,34 +378,34 @@
 		}
 	}
-
+	
 	protected static function commentImages($comment_color,$comment_t,$comment_b,$dest_t,$dest_b)
 	{
 		$comment_color = sscanf($comment_color,'#%2X%2X%2X');
-
+			
 		$d_comment_t = imagecreatetruecolor(500,25);
 		$fill = imagecolorallocate($d_comment_t,$comment_color[0],$comment_color[1],$comment_color[2]);
 		imagefill($d_comment_t,0,0,$fill);
-
+		
 		$s_comment_t = imagecreatefrompng($comment_t);
 		imagealphablending($s_comment_t,true);
 		imagecopy($d_comment_t,$s_comment_t,0,0,0,0,500,25);
-
+		
 		imagepng($d_comment_t,self::imagesPath().'/'.$dest_t);
 		imagedestroy($d_comment_t);
 		imagedestroy($s_comment_t);
-
+		
 		$d_comment_b = imagecreatetruecolor(500,7);
 		$fill = imagecolorallocate($d_comment_b,$comment_color[0],$comment_color[1],$comment_color[2]);
 		imagefill($d_comment_b,0,0,$fill);
-
+		
 		$s_comment_b = imagecreatefrompng($comment_b);
 		imagealphablending($s_comment_b,true);
 		imagecopy($d_comment_b,$s_comment_b,0,0,0,0,500,7);
-
+		
 		imagepng($d_comment_b,self::imagesPath().'/'.$dest_b);
 		imagedestroy($d_comment_b);
 		imagedestroy($s_comment_b);
 	}
-
+	
 	public static function dropImage($img)
 	{
Index: plugins/dcRevisions/_admin.php
===================================================================
--- plugins/dcRevisions/_admin.php	(revision 721)
+++ plugins/dcRevisions/_admin.php	(revision 721)
@@ -0,0 +1,28 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+# 
+# Copyright (c) 2011 Tomtom and contributors
+# http://blog.zenstyle.fr/
+# 
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+if (!defined('DC_CONTEXT_ADMIN')) { return; }
+
+$core->addBehavior('adminPostForm',array('dcRevisionsBehaviors','adminPostForm'));
+$core->addBehavior('adminPostHeaders',array('dcRevisionsBehaviors','adminPostHeaders'));
+$core->addBehavior('adminBeforePostUpdate',array('dcRevisionsBehaviors','adminBeforeUpdate'));
+$core->addBehavior('adminBeforePageUpdate',array('dcRevisionsBehaviors','adminBeforeUpdate'));
+
+$core->rest->addFunction('getPatch',array('dcRevisionsRestMethods','getPatch'));
+
+$core->blog->revisions = new dcRevisions($core);
+
+if (isset($_GET['id']) && isset($_GET['patch']) && preg_match('/post.php\?id=[0-9]+(.*)$/',$_SERVER['REQUEST_URI'])) {
+	$core->blog->revisions->setPatch($_GET['id'],$_GET['patch']);
+}
+
+?>
Index: plugins/dcRevisions/_define.php
===================================================================
--- plugins/dcRevisions/_define.php	(revision 721)
+++ plugins/dcRevisions/_define.php	(revision 721)
@@ -0,0 +1,21 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2011 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+$this->registerModule(
+		/* Name */			"dcRevisions",
+		/* Description*/		"Allows entries's versionning",
+		/* Author */			"Tomtom (http://blog.zenstyle.fr)",
+		/* Version */			'0.1',
+		/* Permissions */		'usage,contentadmin'
+);
+
+?>
Index: plugins/dcRevisions/_install.php
===================================================================
--- plugins/dcRevisions/_install.php	(revision 721)
+++ plugins/dcRevisions/_install.php	(revision 721)
@@ -0,0 +1,65 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2011 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+if (!defined('DC_CONTEXT_ADMIN')) { return; }
+
+$m_version = $core->plugins->moduleInfo('dcRevisions','version');
+$i_version = $core->getVersion('dcrevisions');
+
+if (version_compare($i_version,$m_version,'>=')) {
+	return;
+}
+
+$core->blog->settings->addNamespace('dcrevisions');
+$core->blog->settings->dcrevisions->put(
+	'enable',
+	false,
+	'boolean','Enable revisions',false,true
+);
+
+# --INSTALL AND UPDATE PROCEDURES--
+$s = new dbStruct($core->con,$core->prefix);
+
+$s->revision
+	->revision_id				('bigint',0,false)
+	->post_id					('bigint',0,false)
+	->user_id					('varchar',32,false)
+	->blog_id					('varchar',32,false)
+	->revision_dt				('timestamp',0,false,'now()')
+	->revision_tz				('varchar',128,false,"'UTC'")
+	->revision_type			('varchar',50,true,null)
+	->revision_excerpt_diff		('text',0,true,null)
+	->revision_excerpt_xhtml_diff	('text',0,true,null)
+	->revision_content_diff		('text',0,true,null)
+	->revision_content_xhtml_diff	('text',0,true,null)
+	;
+
+$s->revision->primary('pk_revision','revision_id');
+
+$s->revision->index('idx_revision_post_id','btree','post_id');
+
+$s->revision->reference('fk_revision_post','post_id','post','post_id','cascade','cascade');
+$s->revision->reference('fk_revision_blog','blog_id','blog','blog_id','cascade','cascade');
+
+$si = new dbStruct($core->con,$core->prefix);
+
+try {
+	$changes = $si->synchronize($s);
+} catch (Exception $e) {
+	$core->error->add($e);
+}
+
+$core->setVersion('dcrevisions',$m_version);
+
+return true;
+
+?>
Index: plugins/dcRevisions/_prepend.php
===================================================================
--- plugins/dcRevisions/_prepend.php	(revision 721)
+++ plugins/dcRevisions/_prepend.php	(revision 721)
@@ -0,0 +1,19 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRrevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2011 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+$__autoload['dcRevisions'] = dirname(__FILE__).'/inc/class.dc.revisions.php';
+$__autoload['dcRevisionsRestMethods'] = dirname(__FILE__).'/_services.php';
+$__autoload['dcRevisionsBehaviors'] = dirname(__FILE__).'/inc/class.dc.revisions.behaviors.php';
+$__autoload['dcRevisionsExtensions'] = dirname(__FILE__).'/inc/class.dc.revisions.extensions.php';
+$__autoload['dcRevisionsList'] = dirname(__FILE__).'/inc/class.dc.revisions.list.php';
+
+?>
Index: plugins/dcRevisions/_services.php
===================================================================
--- plugins/dcRevisions/_services.php	(revision 721)
+++ plugins/dcRevisions/_services.php	(revision 721)
@@ -0,0 +1,90 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2011 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+class dcRevisionsRestMethods
+{
+	public static function getPatch()
+	{
+		global $core;
+		
+		$pid = isset($_GET['pid']) ? $_GET['pid'] : null;
+		$rid = isset($_GET['rid']) ? $_GET['rid'] : null;
+		
+		if ($pid === null) {
+			throw new Exception(__('No post ID'));
+		}
+		if ($rid === null) {
+			throw new Exception(__('No revision ID'));
+		}
+		
+		$p = $core->blog->getPosts(array('post_id' => $pid));
+		$o = array(
+			'post_excerpt_xhtml' => $p->post_excerpt_xhtml,
+			'post_content_xhtml' => $p->post_content_xhtml
+		);
+		
+		$n = $core->blog->revisions->getPatch($pid,$rid);
+		unset($n['post_excerpt']);
+		unset($n['post_content']);
+		
+		$rsp = new xmlTag();
+		
+		foreach ($o as $k => $v) {
+			$rsp->insertNode(self::buildNode($v,$n[$k],2,$k));
+		}
+		
+		return $rsp;
+	}
+	
+	public static function buildNode($src,$dst,$ctx,$root)
+	{
+		$udiff = diff::uniDiff($src,$dst,$ctx);
+		$tdiff = new tidyDiff(htmlspecialchars($udiff),true);
+		
+		$rev = new xmlTag($root);
+		
+		foreach ($tdiff->getChunks() as $k => $chunk) {
+			foreach ($chunk->getLines() as $line) {
+				switch ($line->type) {
+					case 'context':
+						$node = new xmlTag('context');
+						$node->oline = $line->lines[0];
+						$node->nline = $line->lines[1];
+						$node->insertNode($line->content);
+						$rev->insertNode($node);
+						break;
+					case 'delete':
+						$node = new xmlTag('delete');
+						$node->oline = $line->lines[0];
+						$c = str_replace(array('\0','\1'),array('<del>','</del>'),$line->content);
+						$node->insertNode($c);
+						$rev->insertNode($node);
+						break;
+					case 'insert':
+						$node = new xmlTag('insert');
+						$node->nline = $line->lines[1];
+						$c = str_replace(array('\0','\1'),array('<ins>','</ins>'),$line->content);
+						$node->insertNode($c);
+						$rev->insertNode($node);
+						break;
+				}
+			}
+			if ($k < count($tdiff->getChunks()) - 1) {
+				$node = new xmlTag('skip');
+				$rev->insertNode($node);
+			}
+		}
+		return $rev;
+	}
+}
+
+?>
Index: plugins/dcRevisions/inc/class.dc.revisions.behaviors.php
===================================================================
--- plugins/dcRevisions/inc/class.dc.revisions.behaviors.php	(revision 721)
+++ plugins/dcRevisions/inc/class.dc.revisions.behaviors.php	(revision 721)
@@ -0,0 +1,72 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2010 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+class dcRevisionsBehaviors
+{
+	public static function adminPostForm($post)
+	{
+		global $core;
+		
+		$id = isset($post) && !$post->isEmpty() ? $post->post_id : null;
+		$page = isset($_GET['page']) ? $_GET['page'] : 1;
+		$url = sprintf('post.php?id=%1$s&amp;patch=%2$s',$id,'%s');
+		
+		$params = array(
+			'post_id' => $id
+		);
+		
+		$rs = $core->blog->revisions->getRevisions($params);
+		
+		if (is_null($id)) {
+			$rs = staticRecord::newFromArray(array());
+			$rs->core = $core;
+		}
+		
+		$list = new dcRevisionsList($rs);
+		
+		echo '<div class="area" id="revisions-area"><label>'.__('Revisions:').'</label>'.
+		$list->display($url).
+		'</div>';
+	}
+	
+	public static function adminPostHeaders()
+	{
+		return
+		'<script type="text/javascript">'."\n".
+		"//<![CDATA[\n".
+		dcPage::jsVar('dotclear.msg.excerpt',__('Excerpt')).
+		dcPage::jsVar('dotclear.msg.content',__('Content')).
+		dcPage::jsVar('dotclear.msg.current',__('Current')).
+		dcPage::jsVar('dotclear.msg.content_identical',__('Content identical')).
+		dcPage::jsVar('dotclear.msg.confirm_apply_patch',
+			__('(CAUTION: This operation will replace all the content by the previous one)').' '.
+			__('Are you sure to want apply this patch on this entry?')
+		).
+		"\n//]]>\n".
+		"</script>\n".
+		'<script type="text/javascript" src="index.php?pf=dcRevisions/js/_revision.js"></script>'."\n".
+		'<link rel="stylesheet" type="text/css" href="index.php?pf=dcRevisions/style.css" />';
+	}
+	
+	public static function adminBeforeUpdate($cur,$post_id)
+	{
+		global $core;
+		
+		try {
+			$core->blog->revisions->addRevision($cur,$post_id);
+		} catch (Exception $e) {
+			$core->error->add($e->getMessage());
+		}
+	}
+}
+
+?>
Index: plugins/dcRevisions/inc/class.dc.revisions.extensions.php
===================================================================
--- plugins/dcRevisions/inc/class.dc.revisions.extensions.php	(revision 338)
+++ plugins/dcRevisions/inc/class.dc.revisions.extensions.php	(revision 338)
@@ -0,0 +1,73 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2010 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+class dcRevisionsExtensions
+{
+	public static function getDate($rs,$format = null)
+	{
+		$format === null ? $format = $rs->core->blog->settings->system->date_format : $format;
+		
+		return dt::dt2str($format,$rs->revision_dt,$rs->revision_tz);
+	}
+	
+	public static function getTime($rs,$format = null)
+	{	
+		$format === null ? $format = $rs->core->blog->settings->system->time_format : $format;
+
+		return dt::dt2str($format,$rs->revision_dt,$rs->revision_tz);
+	}
+	
+	public static function getAuthorCN($rs)
+	{
+		return dcUtils::getUserCN($rs->user_id, $rs->user_name,
+		$rs->user_firstname, $rs->user_displayname);
+	}
+	
+	public static function getAuthorLink($rs)
+	{
+		$res = '%1$s';
+		$url = $rs->user_url;
+		if ($url) {
+			$res = '<a href="%2$s">%1$s</a>';
+		}
+		
+		return sprintf($res,html::escapeHTML($rs->getAuthorCN()),html::escapeHTML($url));
+	}
+	
+	public static function canPatch($rs)
+	{
+		# If user is super admin, true
+		if ($rs->core->auth->isSuperAdmin()) {
+			return true;
+		}
+		
+		# If user is admin or contentadmin, true
+		if ($rs->core->auth->check('contentadmin',$rs->core->blog->id)) {
+			return true;
+		}
+		
+		# No user id in result ? false
+		if (!$rs->exists('user_id')) {
+			return false;
+		}
+		
+		# If user is usage and owner of the entrie
+		if ($rs->core->auth->check('usage',$rs->core->blog->id)
+		&& $rs->user_id == $rs->core->auth->userID()) {
+			return true;
+		}
+		
+		return false;
+	}
+}
+
+?>
Index: plugins/dcRevisions/inc/class.dc.revisions.list.php
===================================================================
--- plugins/dcRevisions/inc/class.dc.revisions.list.php	(revision 721)
+++ plugins/dcRevisions/inc/class.dc.revisions.list.php	(revision 721)
@@ -0,0 +1,86 @@
+<?php
+# -- BEGIN LICENSE BLOCK ----------------------------------
+# This file is part of dcRevisions, a plugin for Dotclear.
+#
+# Copyright (c) 2010 Tomtom and contributors
+# http://blog.zenstyle.fr/
+#
+# Licensed under the GPL version 2.0 license.
+# A copy of this license is available in LICENSE file or at
+# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
+# -- END LICENSE BLOCK ------------------------------------
+
+class dcRevisionsList
+{
+	protected $rs = null;
+	
+	public function __construct($rs)
+	{
+		$this->rs = $rs;
+		$this->core = $rs->core;
+	}
+	
+	public function display($url)
+	{
+		$res = '';
+		
+		if (!$this->rs->isEmpty()) {
+			$html_block =
+				'<table id="revisions-list" summary="'.__('Revisions').'" class="clear maximal" style="display: none;">'.
+				'<thead>'.
+				'<tr>'.
+				'<th>'.__('Id').'</th>'.
+				'<th class="nowrap">'.__('Author').'</th>'.
+				'<th class="nowrap">'.__('Date').'</th>'.
+				'<th class="nowrap">'.__('Status').'</th>'.
+				'<th class="nowrap">'.__('Actions').'</th>'.
+				'</tr>'.
+				'</thead>'.
+				'<tbody>%s</tbody>'.
+				'</table>';
+				
+			$res .= sprintf($html_block,$this->getLines($url));
+		}
+		else {
+			$res .= '<p style="display:none">'.__('No revision').'</p>';
+		}
+		
+		return $res;
+	}
+	
+	private function getLines($url)
+	{
+		$res = '';
+		$p_img = '<img src="%1$s" alt="%2$s" title="%2$s" />';
+		$p_link = '<a href="%1$s" title="%3$s" class="patch"><img src="%2$s" alt="%3$s" /></a>';
+		
+		while ($this->rs->fetch()) {
+			$res .= 
+				'<tr class="line wide'.(!$this->rs->canPatch() ? ' offline' : '').'" id="r'.$this->rs->revision_id.'">'."\n".
+				'<td class="maximal nowrap rid">'.
+					'<strong>'.sprintf(__('Revision #%s'),$this->rs->revision_id).'</strong>'.
+				"</td>\n".
+				'<td class="minimal nowrap">'.
+					$this->rs->getAuthorLink().
+				"</td>\n".
+				'<td class="minimal nowrap">'.
+					$this->rs->getDate().' - '.$this->rs->getTime().
+				"</td>\n".
+				'<td class="minimal nowrap status">'.
+					sprintf(
+						$p_img,
+						('images/'.($this->rs->canPatch() ? 'check-on.png' : 'locker.png')),
+						($this->rs->canPatch() ? __('Revision allowed') : __('Revision blocked'))
+					).
+				"</td>\n".
+				'<td class="minimal nowrap status">'.
+					($this->rs->canPatch() ? sprintf($p_link,sprintf($url,$this->rs->revision_id),'index.php?pf=dcRevisions/images/apply.png',__('Apply patch')) : '').
+				"</td>\n".
+				"</tr>\n";
+		}
+		
+		return $res;
+	}
+}
+
+?>
